/*

mop.h version 2.4  --  21.03.00
=================

P.E.Holmes and R.A.Wilson

09.09.09 New version of CPWR written
26.05.09 Bug in MULCO1 corrected

*/
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
int PRINT;
unsigned char *vecarray[991];
unsigned char v3[4][7];
unsigned char orvec1[41808],orvec2[41808],vorvec[41808];
unsigned char  vec0[41808],vec1[41808],vec2[41808],vec3[41808],vec4[41808];
long ptr1, ptr2, ct;
unsigned char vechead[12],mathead[12];
unsigned char s24head[12];
unsigned char s298head[12];
unsigned char s4096head[12];
char co1head[8],Thead[8];
unsigned char vectemp[41808];
unsigned char t64head[12];
unsigned char t850head[12];
/*
unsigned char *addtab[243];
*/
#define ALIGN_WIDTH 32

typedef char AddLine[243];
  AddLine * addtab;

long *gettrittab[5];
long threepow[5];
unsigned char *grs850tab[43740];
unsigned char *grs64tab[3888];
unsigned char *rows850[5];
unsigned char *rows64[5];
unsigned char *grs850tabi[43740];
unsigned char *grs64tabi[3888];
unsigned char *rowsi850[5];
unsigned char *rowsi64[5];
unsigned char *rows4096[2];
#define l24 ((((24-1)/5)/sizeof(long))+1)
#define l298 ((((298-1)/5)/sizeof(long))+1)
#define l4096 ((((4096-1)/5)/sizeof(long))+1)
#define l64 ((((64-1)/5)/sizeof(long))+1)
#define l850 ((((850-1)/5)/sizeof(long))+1)
struct co1y {
    long * m24;
    long * m298;
    long * p98280;
    unsigned char * b98280;
    long * m4096;
    long * m24t;
    unsigned char *grs4096tab[36856];
} co1ex;
typedef struct co1y * co1el;
unsigned char *bss[1000];
long *poslst1, *poslst2, *poslst3, *poslst4, *poslst5;
co1el A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, AA, BB, CC, DD, EE, FF, tempco1;
long * m64;
long * m850;
long * p147456;
unsigned char * b147456;
long * mi64;
long * mi850;
long * pi147456;
unsigned char * bi147456;

void malco1(co1el  * m)
{
    co1el t;
    *m=(co1el)malloc(sizeof(co1ex));
    t=*m;
    t->m24 = malloc(24*l24*sizeof(long));
    t->m298 = malloc(298*l298*sizeof(long));
    t->m4096 = malloc(4096*l4096*sizeof(long));
    t->p98280 = malloc(98281*sizeof(long));
    t->b98280 = malloc(98281);
    t->m24t = malloc(24*l24*sizeof(long));
    for(ct=0;ct<36856;ct++) t->grs4096tab[ct]=(unsigned char *)malloc(820); 
}

void malBco1(co1el  * m)
{
    co1el t;
    *m=(co1el)malloc(sizeof(co1ex));
    t=*m;
    t->m24 = malloc(24*l24*sizeof(long));
    t->m24t = malloc(24*l24*sizeof(long));
    t->m298 = malloc(298*l298*sizeof(long));
    t->m4096 = malloc(4096*l4096*sizeof(long));
    t->p98280 = malloc(98281*sizeof(long));
    t->b98280 = malloc(98281);
}

void malT()
{
    m64 = malloc(65*l64*sizeof(long));
    m850 = malloc(850*l850*sizeof(long));
    p147456 = malloc(147457*sizeof(long));
    b147456 = malloc(147457);
    for(ct=0;ct<5;ct++) rows850[ct]=(unsigned char *)malloc(180); 
    for(ct=0;ct<5;ct++) rows64[ct]=(unsigned char *)malloc(16); 
    for(ct=0;ct<43740;ct++) grs850tab[ct]=(unsigned char *)malloc(180); 
    for(ct=0;ct<3888;ct++) grs64tab[ct]=(unsigned char *)malloc(16);
}

void malTi()
{
    mi64 = malloc(65*l64*sizeof(long));
    mi850 = malloc(850*l850*sizeof(long));
    pi147456 = malloc(147457*sizeof(long));
    bi147456 = malloc(147457);
    for(ct=0;ct<43740;ct++) grs850tabi[ct]=(unsigned char *)malloc(180); 
    for(ct=0;ct<3888;ct++) grs64tabi[ct]=(unsigned char *)malloc(16);
}

/* note that POW is almost obsolete */
int POW(long a, long b)
{
    long i,j;
    j=1;
    for(i=1;i<=b;i++)
    {
	j=j*a;
    }
    return(j);
}

/* note that GETTRIT is obsolete */
unsigned char GETTRIT(unsigned char *v, long pt)
{
    unsigned char curbt;
    long posinbt;
    unsigned char trit;
    curbt=v[pt/5];
    posinbt=4-(pt%5);
    trit=(curbt%(POW(3,(posinbt+1))))/(POW(3,posinbt));
    return trit;
}

void PUTTRIT(unsigned char *v, long pt, unsigned char trit)
{
    unsigned char curbt;
    long posinbt;
    curbt=v[pt/5];
    posinbt=4-(pt%5);
    curbt=curbt+(trit*(POW(3,posinbt)));
    v[pt/5]=curbt;
    return;    
}

/* note that trits are labelled from the left, so tab[3]["21102"] is 0 */

void MKTRITTAB()
{
    long i, j;
    for(i=0;i<5;i++)
    {
	gettrittab[i]=malloc(243*sizeof(long));
	for(j=0;j<243;j++)    gettrittab[i][j]=(j%(POW(3,4-i+1)))/(POW(3,4-i));
    }
}

int cpvec(unsigned char *veca, unsigned char * vecb, long l1, long l2)
{
    long i;
    unsigned char *ptc1, *ptc2;
    ptc1=veca;
    ptc2=vecb;
    for (i=0;i<l1;i++) 
    {	
	*(ptc2++);
	*(ptc1++);
    }
    for (i=l1;i<l2;i++) *(ptc2++)=*(ptc1++);
}

void MKADDTAB()
{
    long i,k,pt,j;
    unsigned char *trtB,trtA,tabrow[243];
  unsigned int ii;
  unsigned int diff, offs;
char *tabledata;

    trtB=malloc(5*sizeof(long));
  tabledata = (char*)malloc(243*243+ALIGN_WIDTH);
  diff = ((unsigned int)tabledata) % ALIGN_WIDTH;
  offs = ALIGN_WIDTH - diff;

  addtab = (AddLine*)(tabledata+offs);  


    for(i=0;i<243;i++) 
    {
	tabrow[i]=i;
	for(j=0;j<243;j++) addtab[i][j]=0;
    }
    for(i=0;i<243;i++) 
    {
	for(k=0;k<5;k++) 
	{
	    trtB[k]=(i%(POW(3,((4-k)+1))))/(POW(3,(4-k)));
	}
	for(pt=0;pt<(243*5);pt++)
	{
	    trtA=gettrittab[pt%5][tabrow[pt/5]];
	    trtA=(trtA+trtB[pt%5])%3;
	    PUTTRIT(addtab[i],pt,trtA);
	}
    }   
} 

void VECADD(unsigned char * old, unsigned char * new, long l1, long l2)
{
   unsigned char tempbyte;
    long i;
    unsigned char * ptr;
    ptr=old;
    for(i=l1;i<l2;i++)
    {
	tempbyte=addtab[old[i]][new[i]];
	old[i]=tempbyte; 
     }
 }

void VECADD2(unsigned char * old, unsigned char * new, long l1, long l2)
{
   unsigned char tempbyte;
    long i;
    unsigned char * ptr;
    ptr=old;
    for(i=l1;i<l2;i++)
    {
	tempbyte=addtab[old[i]][new[i-l1]];
	old[i]=tempbyte; 
     }
 }

void VECADD3(unsigned char * old, unsigned char * new, long l1, long l2, long l3)
{
   unsigned char tempbyte;
    long i,l4;
    unsigned char * ptr;
    ptr=old;
    for(i=l1;i<l2;i++)
    {
	tempbyte=addtab[old[i]][new[i-l1+l3]];
	old[i]=tempbyte; 
     }
 }

void MKGRS850()
{
    long i,j,k,l,trtB;
    long * ptrl;
    unsigned char * ptr;
    unsigned char *tempgs[243];
    ptrl = m850;
    ptr = (unsigned char *) m850;
    for(i=0;i<243;i++) 
    {
	tempgs[i]=(unsigned char *)malloc(180);
    }
    for(i=0;i<170;i++) 
    {
        for(k=0;k<243;k++) 
        {
	    for(j=0;j<180;j++) tempgs[k][j]=0;
        }
	for(j=0;j<5;j++)
	{
	    cpvec(ptr,rows850[j],0,170);
	    ptr+=l850*sizeof(long);
	}
	for(j=0;j<243;j++) 
	{
	    for(k=0;k<5;k++) 
	    {
		trtB=gettrittab[4-k][j];
		for(l=0;l<trtB;l++) VECADD(tempgs[j], rows850[4-k], 0, 170);
	    }
	}
	for(j=0;j<243;j++) cpvec(tempgs[j],grs850tab[(243*i)+j],0,170);
    }
}

void MKGRS850i()
{
    long i,j,k,l,trtB;
    long * ptrl;
    unsigned char * ptr;
    unsigned char *tempgs[243];
    ptrl = mi850;
    ptr = (unsigned char *) mi850;
    for(i=0;i<243;i++) 
    {
	tempgs[i]=(unsigned char *)malloc(180);
    }
    for(i=0;i<170;i++) 
    {
        for(k=0;k<243;k++) 
        {
	    for(j=0;j<180;j++) tempgs[k][j]=0;
        }
	for(j=0;j<5;j++)
	{
	    cpvec(ptr,rows850[j],0,170);
	    ptr+=l850*sizeof(long);
	}
	for(j=0;j<243;j++) 
	{
	    for(k=0;k<5;k++) 
	    {
		trtB=gettrittab[4-k][j];
		for(l=0;l<trtB;l++) VECADD(tempgs[j], rows850[4-k], 0, 170);
	    }
	}
	for(j=0;j<243;j++) cpvec(tempgs[j],grs850tabi[(243*i)+j],0,170);
    }
}

void MKGRS850B()
{
    long i,j,k,l,trtB;
    long * ptrl;
    unsigned char * ptr;
    unsigned char *tempgs[243];
    ptrl = m850;
    ptr = (unsigned char *) m850;
    for(i=0;i<243;i++) 
    {
	tempgs[i]=(unsigned char *)malloc(180);
    }
    for(i=0;i<170;i++) 
    {
	for(j=0;j<180;j++) tempgs[0][j]=0;
	for(j=0;j<5;j++)
	{
	    cpvec(ptr,rows850[j],0,820);
	    ptr+=l850*sizeof(long);
	}
	cpvec(rows850[4], tempgs[1], 0,180);
	cpvec(rows850[4], tempgs[2], 0,180);
	VECADD(tempgs[2], rows850[2], 0, 180);
	cpvec(rows850[3], tempgs[3], 0,180);
	for(j=1;j<=5;j++)
	{
	    cpvec(tempgs[3],tempgs[3+j],0,180);
	    VECADD(tempgs[3+j], tempgs[j], 0, 180);
	}
	cpvec(rows850[2],tempgs[9],0,180);
	for(j=1;j<=17;j++)
	{
	    cpvec(tempgs[9],tempgs[9+j],0,180);
	    VECADD(tempgs[9+j], tempgs[j], 0, 180);
	}
	cpvec(rows850[1],tempgs[27],0,180);
	for(j=1;j<=53;j++)
	{
	    cpvec(tempgs[27],tempgs[27+j],0,180);
	    VECADD(tempgs[27+j], tempgs[j], 0, 180);
	}
	cpvec(rows850[0],tempgs[81],0,180);
	for(j=1;j<=161;j++)
	{
	    cpvec(tempgs[81],tempgs[81+j],0,180);
	    VECADD(tempgs[81+j], tempgs[j], 0, 180);
	}
	for(j=0;j<243;j++) cpvec(tempgs[j],grs850tab[(243*i)+j],0,180);
    }
}

void MKGRS850Bi()
{
    long i,j,k,l,trtB;
    long * ptrl;
    unsigned char * ptr;
    unsigned char *tempgs[243];
    ptrl = mi850;
    ptr = (unsigned char *) mi850;
    for(i=0;i<243;i++) 
    {
	tempgs[i]=(unsigned char *)malloc(180);
    }
    for(i=0;i<170;i++) 
    {
	for(j=0;j<180;j++) tempgs[0][j]=0;
	for(j=0;j<5;j++)
	{
	    cpvec(ptr,rows850[j],0,820);
	    ptr+=l850*sizeof(long);
	}
	cpvec(rows850[4], tempgs[1], 0,180);
	cpvec(rows850[4], tempgs[2], 0,180);
	VECADD(tempgs[2], rows850[2], 0, 180);
	cpvec(rows850[3], tempgs[3], 0,180);
	for(j=1;j<=5;j++)
	{
	    cpvec(tempgs[3],tempgs[3+j],0,180);
	    VECADD(tempgs[3+j], tempgs[j], 0, 180);
	}
	cpvec(rows850[2],tempgs[9],0,180);
	for(j=1;j<=17;j++)
	{
	    cpvec(tempgs[9],tempgs[9+j],0,180);
	    VECADD(tempgs[9+j], tempgs[j], 0, 180);
	}
	cpvec(rows850[1],tempgs[27],0,180);
	for(j=1;j<=53;j++)
	{
	    cpvec(tempgs[27],tempgs[27+j],0,180);
	    VECADD(tempgs[27+j], tempgs[j], 0, 180);
	}
	cpvec(rows850[0],tempgs[81],0,180);
	for(j=1;j<=161;j++)
	{
	    cpvec(tempgs[81],tempgs[81+j],0,180);
	    VECADD(tempgs[81+j], tempgs[j], 0, 180);
	}
	for(j=0;j<243;j++) cpvec(tempgs[j],grs850tabi[(243*i)+j],0,180);
    }
}

void MKGRS64()
{
    long i,j,k,l,trtB;
    long * ptrl;
    unsigned char * ptr;
    unsigned char *tempgs[243];
    ptrl = m64;
    ptr = (unsigned char *) m64;
    for(i=0;i<243;i++) 
    {
	tempgs[i]=(unsigned char *)malloc(16);
    }
    for(i=0;i<13;i++) 
    {
        for(k=0;k<243;k++) 
        {
	    for(j=0;j<16;j++) tempgs[k][j]=0;
        }
	for(j=0;j<5;j++)
	{
	    cpvec(ptr,rows64[j],0,13);
	    ptr+=l64*sizeof(long);
	}
	for(j=0;j<243;j++) 
	{
	    for(k=0;k<5;k++) 
	    {
		trtB=gettrittab[4-k][j];
		for(l=0;l<trtB;l++) VECADD(tempgs[j], rows64[4-k], 0, 13);
	    }
	}
	for(j=0;j<243;j++) cpvec(tempgs[j],grs64tab[(243*i)+j],0,13);
   }
}
	  
void MKGRS64i()
{
    long i,j,k,l,trtB;
    long * ptrl;
    unsigned char * ptr;
    unsigned char *tempgs[243];
    ptrl = mi64;
    ptr = (unsigned char *) mi64;
    for(i=0;i<243;i++) 
    {
	tempgs[i]=(unsigned char *)malloc(16);
    }
    for(i=0;i<13;i++) 
    {
        for(k=0;k<243;k++) 
        {
	    for(j=0;j<16;j++) tempgs[k][j]=0;
        }
	for(j=0;j<5;j++)
	{
	    cpvec(ptr,rows64[j],0,13);
	    ptr+=l64*sizeof(long);
	}
	for(j=0;j<243;j++) 
	{
	    for(k=0;k<5;k++) 
	    {
		trtB=gettrittab[4-k][j];
		for(l=0;l<trtB;l++) VECADD(tempgs[j], rows64[4-k], 0, 13);
	    }
	}
	for(j=0;j<243;j++) cpvec(tempgs[j],grs64tabi[(243*i)+j],0,13);
   }
}

void MKGRS4096A(co1el m)
{
    long i,j,k,l,trtB;
    long * ptrl, ptrlB;
    unsigned char * ptr, * ptrB[36856];
    unsigned char *tempgs[27];
    ptrl = m->m4096;
    ptr = (unsigned char *) m->m4096;
    for(i=0;i<36856;i++) ptrB[i] = (unsigned char *) m->grs4096tab[i];
    for(i=0;i<27;i++) 
    {
	tempgs[i]=(unsigned char *)malloc(820);
    }
    for(i=0;i<1365;i++) 
    {
	for(j=0;j<820;j++) tempgs[0][j]=0;
	for(j=0;j<3;j++)
	{
	    cpvec(ptr,rows4096[j],0,820);
	    ptr+=l4096*sizeof(long);
	}
	cpvec(rows4096[2], tempgs[1], 0,820);
	cpvec(rows4096[2], tempgs[2], 0,820);
	VECADD(tempgs[2], rows4096[2], 0, 820);
	cpvec(rows4096[1], tempgs[3], 0,820);
	for(j=1;j<=5;j++)
	{
	    cpvec(tempgs[3],tempgs[3+j],0,820);
	    VECADD(tempgs[3+j], tempgs[j], 0, 820);
	}
	cpvec(rows4096[0],tempgs[9],0,820);
	for(j=1;j<=17;j++)
	{
	    cpvec(tempgs[9],tempgs[9+j],0,820);
	    VECADD(tempgs[9+j], tempgs[j], 0, 820);
	}
	for(j=0;j<27;j++) cpvec(tempgs[j],ptrB[(27*i)+j],0,820);
   }
   cpvec(ptr,ptrB[36855],0,820);
}

void transpose24(co1el m)
{
    long i,j,trtA;
    unsigned char * ptrA, * ptrB;
    ptrA = (unsigned char *) m->m24;
    ptrB = (unsigned char *) m->m24t;	
    for(i=0;i<24;i++)
    {
	for(j=0;j<24;j++)
	{
	    trtA=gettrittab[j%5][ptrA[j/5]];
	    if(trtA!=0) PUTTRIT(ptrB,i,trtA);
	    ptrB+=l24*sizeof(long);
	}
	ptrB =(unsigned char *) m->m24t;	
	ptrA+=l24*sizeof(long);
    }
}
	    
	  
void FGAP(unsigned char *vin, unsigned char *vout, long f, long g)
{
    long h, trtA;
    for (h=0;h<f;h++)
    {
	trtA=gettrittab[ptr1%5][vin[ptr1/5]];
	if(trtA!=0) PUTTRIT(vout, ptr2, trtA);
	ptr2++;
	ptr1++;
    }
    ptr2+=g;
}

void FUNGAP(unsigned char *vin, unsigned char *vout, long f, long g)
{
    long h,trtA;
    for (h=0;h<f;h++)
    {
	trtA=gettrittab[ptr2%5][vin[ptr2/5]];
	if(trtA!=0) PUTTRIT(vout, ptr1, trtA);
	ptr1++;
	ptr2++;
    }
    ptr2+=g;
}

void NEWPAD(unsigned char *vecout, unsigned char *vecin)
{
    long i;
    for (i=0;i<39377;i++) vectemp[i]=0;
    ptr1=0;
    ptr2=0;
    FUNGAP(vecout,vectemp,298,2);
    FUNGAP(vecout,vectemp,98280,0);
    for (i=0;i<24;i++)     FUNGAP(vecout,vectemp,4096,4);
    for (i=0;i<41808;i++) vecin[i]=0;
    ptr1=0;
    ptr2=0;
    FGAP(vectemp,vecin,850,10);
    for (i=0;i<759;i++)     FGAP(vectemp,vecin,64,16);
    FGAP(vectemp,vecin,147456,4);
    
}

void OLDPAD(unsigned char *vecout, unsigned char *vecin)
{
    long i;
    for (i=0;i<39377;i++) vectemp[i]=0;
    ptr1=0;
    ptr2=0;
    FUNGAP(vecout,vectemp,850,10);
    for (i=0;i<759;i++)     FUNGAP(vecout,vectemp,64,16);
    FUNGAP(vecout,vectemp,147456,4);
    for (i=0;i<41808;i++) vecin[i]=0;
    ptr1=0;
    ptr2=0;
    FGAP(vectemp,vecin,298,2);
    FGAP(vectemp,vecin,98280,0);
    for (i=0;i<24;i++)     FGAP(vectemp,vecin,4096,4);    
}

int init()
{
    unsigned char uc;
    int i,j;
    long k,l,m,n;
    strncpy(co1head,"MONCO101",8);
    strncpy(Thead,"MON--T01",8);
    vechead[0]=3;
    vechead[1]=0;
    vechead[2]=0;
    vechead[3]=0;
    vechead[4]=1;
    vechead[5]=0;
    vechead[6]=0;
    vechead[7]=0;
    vechead[8]=18;
    vechead[9]=1;
    vechead[10]=3;
    vechead[11]=0;

    mathead[0]=3;
    mathead[1]=0;
    mathead[2]=0;
    mathead[3]=0;
    mathead[4]=18;
    mathead[5]=1;
    mathead[6]=3;
    mathead[7]=0;
    mathead[8]=18;
    mathead[9]=1;
    mathead[10]=3;
    mathead[11]=0;

    s24head[0]=3;
    s24head[1]=0;
    s24head[2]=0;
    s24head[3]=0;
    s24head[4]=24;
    s24head[5]=0;
    s24head[6]=0;
    s24head[7]=0;
    s24head[8]=24;
    s24head[9]=0;
    s24head[10]=0;
    s24head[11]=0;

    s298head[0]=3;
    s298head[1]=0;
    s298head[2]=0;
    s298head[3]=0;
    s298head[4]=42;
    s298head[5]=1;
    s298head[6]=0;
    s298head[7]=0;
    s298head[8]=42;
    s298head[9]=1;
    s298head[10]=0;
    s298head[11]=0;

    s4096head[0]=3;
    s4096head[1]=0;
    s4096head[2]=0;
    s4096head[3]=0;
    s4096head[4]=0;
    s4096head[5]=16;
    s4096head[6]=0;
    s4096head[7]=0;
    s4096head[8]=0;
    s4096head[9]=16;
    s4096head[10]=0;
    s4096head[11]=0;

    t850head[0]=3;
    t850head[1]=0;
    t850head[2]=0;
    t850head[3]=0;
    t850head[4]=82;
    t850head[5]=3;
    t850head[6]=0;
    t850head[7]=0;
    t850head[8]=82;
    t850head[9]=3;
    t850head[10]=0;
    t850head[11]=0;

    t64head[0]=3;
    t64head[1]=0;
    t64head[2]=0;
    t64head[3]=0;
    t64head[4]=64;
    t64head[5]=0;
    t64head[6]=0;
    t64head[7]=0;
    t64head[8]=64;
    t64head[9]=0;
    t64head[10]=0;
    t64head[11]=0;

    threepow[0]=1;
    threepow[1]=3;
    threepow[2]=9;
    threepow[3]=27;
    threepow[4]=81;

    MKTRITTAB();
    MKADDTAB();
    for(i=0;i<3;i++) rows4096[i]=(unsigned char *)malloc(820); 

}

int rdvec(char* filnam, unsigned char* vecin)
{
    FILE * f ;
    int i,j;
     f = fopen(filnam,"rb");
     if (f == NULL) 
    {
        printf("File %s does not exist!\n",filnam);
        exit(-1);
    }
    fread(vectemp,1,12,f);
    fread(vectemp,1,39377,f);
    fclose(f);
    for (i=0;i<41808;i++) vecin[i]=0;
    ptr1=0;
    ptr2=0;
    FGAP(vectemp,vecin,298,2);
    FGAP(vectemp,vecin,98280,0);
    for (i=0;i<24;i++)     FGAP(vectemp,vecin,4096,4);
}

int mkvec(long coord, unsigned char* vecin)
{
    int i,j;
    for (i=0;i<41808;i++) vecin[i]=0;
    for (i=0;i<39377;i++) vectemp[i]=0;
    PUTTRIT(vectemp,coord,1);
    ptr1=0;
    ptr2=0;
    FGAP(vectemp,vecin,298,2);
    FGAP(vectemp,vecin,98280,0);
    for (i=0;i<24;i++)     FGAP(vectemp,vecin,4096,4);
}
int veccomp(unsigned char *veca, unsigned char * vecb)
{
    long i;
    unsigned char *ptc1, *ptc2;
    ptc1=veca;
    ptc2=vecb;
    for (i=0;i<41808;i++) if (*(ptc1++) != *(ptc2++)) return(i+1);
    return(0);
}


int wtvec(char* filnam, unsigned char* vecout)
{
    FILE * f;
    int i;
    f = fopen(filnam,"wb");
     if (f == NULL) 
    {
        printf("File %s cannot be created!\n",filnam);
        exit(-1);
    }
    fwrite(vechead,1,12,f);
    for (i=0;i<39377;i++) vectemp[i]=0;
    ptr1=0;
    ptr2=0;
    FUNGAP(vecout,vectemp,298,2);
    FUNGAP(vecout,vectemp,98280,0);
    for (i=0;i<24;i++)     FUNGAP(vecout,vectemp,4096,4);
    fwrite(vectemp,1,39377,f);
    fclose(f);
}

int wtvecB(char* filnam, unsigned char* vecout)
{
    FILE * f ;
    int i;
    f = fopen(filnam,"wb");
     if (f == NULL) 
    {
        printf("File %s cannot be created!\n",filnam);
        exit(-1);
    }
    fwrite(vechead,1,12,f);
    for (i=0;i<39377;i++) vectemp[i]=0;
    ptr1=0;
    ptr2=0;
    FUNGAP(vecout,vectemp,850,10);
    for (i=0;i<759;i++)     FUNGAP(vecout,vectemp,64,16);
    FUNGAP(vecout,vectemp,147456,4);
    fwrite(vectemp,1,39377,f);
    fclose(f);
}

int rdco14(co1el m, char * fn1,char * fn2, char * fn3, char* fn4)
{
    FILE * f1 ;
    FILE * f2 ;
    FILE * f3 ;
    FILE * f4 ;
    unsigned char * ptr;
    unsigned char * ptrc;
    long * ptrl;
    long i;
    long j;
    f1= fopen(fn1,"rb");
    if (f1 == NULL) 
    {
        printf("File %s does not exist!\n",fn1);
        exit(-1);
    }
    f2= fopen(fn2,"rb");
    if (f2 == NULL) 
    {
        printf("File %s does not exist!\n",fn2);
        exit(-1);
    }
    f3= fopen(fn3,"r");
    if (f3 == NULL) 
    {
        printf("File %s does not exist!\n",fn3);
        exit(-1);
    }
    f4= fopen(fn4,"rb");
    if (f4 == NULL) 
    {
        printf("File %s does not exist!\n",fn4);
        exit(-1);
    }
    ptr = (unsigned char *) m->m24;
    fread(ptr,1,12,f1);
    for (i=0;i<24;i++) 
    {
        fread(ptr,1,5,f1);
        ptr+=l24*sizeof(long);
    }
    fclose(f1);
    ptr = (unsigned char *) m->m298;
    fread(ptr,1,12,f2);
    for (i=0;i<298;i++) 
    {
        fread(ptr,1,60,f2);
        ptr+=l298*sizeof(long);
    }
    fclose(f2);
    ptr = (unsigned char *) m->m4096;
    fread(ptr,1,12,f4);
    for (i=0;i<4096;i++) 
    {
        fread(ptr,1,820,f4);
        ptr+=l4096*sizeof(long);
    }
    fclose(f4);
    fscanf(f3,"%ld",&i);
    if ( i!=13)
    {
        printf("mop error - not a slum\n");
        exit(22);
    } 
    fscanf(f3,"%ld",&i); 
    if ( i!=3)
    {
        printf("mop error - not an GF3 slum\n");
        exit(22);
    }
    fscanf(f3,"%ld",&i);
    if (i!=98280)
    {
        printf("mop error - not a 98280 slum\n");
        exit(22);
    }
    ptrl=(m->p98280)+1;
    ptrc=(m->b98280)+1;
    for (i=1;i<=98280;i++)
    {
        fscanf(f3,"%ld",ptrl++);
        fscanf(f3,"%ld",&j);
        *ptrc=j;
        ptrc++;
    }
    fclose(f3);
}

int wtco14(co1el m,char * fn1, char * fn2, char * fn3, char * fn4)
{
    FILE * f1 ;
    FILE * f2 ;
    FILE * f3 ;
    FILE * f4 ;
    unsigned char * ptr;
    long * ptrl;
    unsigned char * ptrc;
    long i;
    long j;
    f1= fopen(fn1,"wb");
    if (f1 == NULL) 
    {
        printf("File %s cannot be created!\n",fn1);
        exit(-1);
    }
    f2= fopen(fn2,"wb");
    if (f2 == NULL) 
    {
        printf("File %s cannot be created!\n",fn2);
        exit(-1);
    }
    f3= fopen(fn3,"w");
    if (f3 == NULL) 
    {
        printf("File %s cannot be created!\n",fn3);
        exit(-1);
    }
    f4= fopen(fn4,"wb");
    if (f4 == NULL) 
    {
        printf("File %s cannot be created!\n",fn4);
        exit(-1);
    }
    ptrl = m->m24;
    ptr = (unsigned char *) ptrl;
    fwrite(s24head,1,12,f1);
    for (i=0;i<24;i++) 
    {
        fwrite(ptr,1,5,f1);
        ptr+=l24*sizeof(long);
    }
    fclose(f1);
    fwrite(s298head,1,12,f2);
    ptr = (unsigned char *) m->m298;
    for (i=0;i<298;i++) 
    {
        fwrite(ptr,1,60,f2);
        ptr+=l298*sizeof(long);
    }
    fclose(f2);
    fwrite(s4096head,1,12,f4);
    ptr = (unsigned char *) m->m4096;
    for (i=0;i<4096;i++) 
    {
        fwrite(ptr,1,820,f4);
        ptr+=l4096*sizeof(long);
    }
    fclose(f4);
    fprintf(f3,"13     3 98280\n");
    ptrc=(m->b98280)+1;
    ptrl=(m->p98280)+1;
    for (i=1;i<=98280;i++)
    {
        fprintf(f3,"%8ld",*(ptrl++));
        j=*(ptrc++);
        fprintf(f3,"%2ld\n",j);
    }
    fclose(f3);
}

int wtco1x(co1el m,char * fn1, char * fn2, char * fn3, char * fn4)
{
    FILE * f1 ;
    FILE * f2 ;
    FILE * f3 ;
    FILE * f4 ;
    unsigned char * ptr;
    long * ptrl;
    unsigned char * ptrc;
    long i;
    long j;
    f1= fopen(fn1,"wb");
    if (f1 == NULL) 
    {
        printf("File %s cannot be created!\n",fn1);
        exit(-1);
    }
    f2= fopen(fn2,"wb");
    if (f2 == NULL) 
    {
        printf("File %s cannot be created!\n",fn2);
        exit(-1);
    }
    f3= fopen(fn3,"w");
    if (f3 == NULL) 
    {
        printf("File %s cannot be created!\n",fn3);
        exit(-1);
    }
    f4= fopen(fn4,"wb");
    if (f4 == NULL) 
    {
        printf("File %s cannot be created!\n",fn4);
        exit(-1);
    }
    ptrl = m->m24;
    ptr = (unsigned char *) ptrl;
    fwrite(s24head,1,12,f1);
    for (i=0;i<24;i++) 
    {
        fwrite(ptr,1,5,f1);
        ptr+=l24*sizeof(long);
    }
    fclose(f1);
    fwrite(s298head,1,12,f2);
    ptr = (unsigned char *) m->m298;
    for (i=0;i<298;i++) 
    {
        fwrite(ptr,1,60,f2);
        ptr+=l298*sizeof(long);
    }
    fclose(f2);
    fwrite(s4096head,1,12,f4);
    ptr = (unsigned char *) m->m4096;
    for (i=0;i<4096;i++) 
    {
        fwrite(ptr,1,820,f4);
        ptr+=l4096*sizeof(long);
    }
    fclose(f4);
    fprintf(f3,"13     3 98280\n");
    ptrc=(m->b98280)+1;
    ptrl=(m->p98280)+1;
    for (i=1;i<=98280;i++)
    {
        fprintf(f3,"%8ld",*(ptrl++));
        j=*(ptrc++);
        fprintf(f3,"%2ld\n",j);
    }
    fclose(f3);
}

    
int wtco11(co1el m, char * fn)
{
    FILE * f ;
    unsigned char * ptr;
    long * ptrl;
    unsigned char * ptrc;
    long i;
    long j;
    unsigned char c[4];
    f= fopen(fn,"wb");
    if (f == NULL) 
    {
        printf("File %s cannot be created!\n",fn);
        exit(-1);
    }
    ptrl = m->m24;
    ptr = (unsigned char *) ptrl;
    for (i=0;i<24;i++) 
    {
        fwrite(ptr,1,5,f);
        ptr+=l24*sizeof(long);
    }
    ptr = (unsigned char *) m->m298;
    for (i=0;i<298;i++) 
    {
        fwrite(ptr,1,60,f);
        ptr+=l298*sizeof(long);
    }
    ptr = (unsigned char *) m->m4096;
    for (i=0;i<4096;i++) 
    {
        fwrite(ptr,1,820,f);
        ptr+=l4096*sizeof(long);
    }
    ptrc=(m->b98280)+1;
    ptrl=(m->p98280)+1;
    for (i=1;i<=98280;i++)
    {
        c[0]=(*ptrl)%256;
        c[1]=((*(ptrl))/256)%256;
        c[2]=((*(ptrl++))/256)/256;
        c[3]=*(ptrc++);
        fwrite(c,1,4,f);
    }
    fclose(f);
}

int rdco11(co1el m, char * fn)
{
    FILE * f ;
    unsigned char * ptr;
    long * ptrl;
    unsigned char * ptrc;
    long i;
    long j;
    unsigned char c[4];
    f= fopen(fn,"rb");
    if (f == NULL) 
    {
        printf("File %s does not exist!\n",fn);
        exit(-1);
    }
    ptrl = m->m24;
    ptr = (unsigned char *) ptrl;
    for (i=0;i<24;i++) 
    {
        fread(ptr,1,5,f);
        ptr+=l24*sizeof(long);
    }
    ptr = (unsigned char *) m->m298;
    for (i=0;i<298;i++) 
    {
        fread(ptr,1,60,f);
        ptr+=l298*sizeof(long);
    }
    ptr = (unsigned char *) m->m4096;
    for (i=0;i<4096;i++) 
    {
        fread(ptr,1,820,f);
        ptr+=l4096*sizeof(long);
    }
    ptrc=(m->b98280)+1;
    ptrl=(m->p98280)+1;
    for (i=1;i<=98280;i++)
    {
        fread(c,1,4,f);
        *(ptrc++)=c[3];
        j=256*256*c[2]+256*c[1]+c[0];
        *(ptrl++)=j;
    }
    fclose(f);
    transpose24(m);
}


int rdT3(char * fn1, char * fn2, char * fn3)
{
    FILE * f1 ;
    FILE * f2 ;
    FILE * f3 ;
    FILE * f4 ;
    unsigned char * ptr;
    unsigned char * ptrc;
    long * ptrl;
    long i;
    long j;
    f1= fopen(fn1,"rb");
    if (f1 == NULL) 
    {
        printf("File %s does not exist!\n",fn1);
        exit(-1);
    }
    f2= fopen(fn2,"rb");
    if (f2 == NULL) 
    {
        printf("File %s does not exist!\n",fn2);
        exit(-1);
    }
    f3= fopen(fn3,"r");
    if (f3 == NULL) 
    {
        printf("File %s does not exist!\n",fn3);
        exit(-1);
    }
    malT();
    ptr = (unsigned char *) m64;
    fread(ptr,1,12,f1);
    for (i=0;i<64;i++) 
    {
        fread(ptr,1,13,f1);
        ptr+=l64*sizeof(long);
    }
    *(ptr)=0000000000000000;
    fclose(f1);
    ptr = (unsigned char *) m850;
    fread(ptr,1,12,f2);
    for (i=0;i<850;i++) 
    {
        fread(ptr,1,170,f2);
        ptr+=l850*sizeof(long);
    }
    fclose(f2);
    fscanf(f3,"%ld",&i);
    if ( i!=13)
    {
        printf("mop error - not a slum\n");
        exit(22);
    } 
    fscanf(f3,"%ld",&i); 
    if ( i!=3)
    {
        printf("mop error - not an GF3 slum\n");
        exit(22);
    }
    fscanf(f3,"%ld",&i);
    if (i!=147456)
    {
        printf("mop error - not a 147456 slum\n");
        exit(22);
    }
    ptrl=(p147456)+1;
    ptrc=(b147456)+1;
    for (i=1;i<=147456;i++)
    {
        fscanf(f3,"%ld",ptrl++);
        fscanf(f3,"%ld",&j);
        *ptrc=j;
        ptrc++;
    }
    fclose(f3);
}

int wtT3(char * fn1, char * fn2, char * fn3)
{
    FILE * f1 ;
    FILE * f2 ;
    FILE * f3 ;
    FILE * f4 ;
    unsigned char * ptr;
    long * ptrl;
    unsigned char * ptrc;
    long i;
    long j;
    f1= fopen(fn1,"wb");
    if (f1 == NULL) 
    {
        printf("File %s cannot be created!\n",fn1);
        exit(-1);
    }
    f2= fopen(fn2,"wb");
    if (f2 == NULL) 
    {
        printf("File %s cannot be created!\n",fn2);
        exit(-1);
    }
    f3= fopen(fn3,"w");
    if (f3 == NULL) 
    {
        printf("File %s cannot be created!\n",fn3);
        exit(-1);
    }
    fwrite(t64head,1,12,f1);
    ptrl = m64;
    ptr = (unsigned char *) ptrl;
    for (i=0;i<64;i++) 
    {
        fwrite(ptr,1,13,f1);
        ptr+=l64*sizeof(long);
    }
    fclose(f1);
    fwrite(t850head,1,12,f2);
    ptr = (unsigned char *) m850;
    for (i=0;i<850;i++) 
    {
        fwrite(ptr,1,170,f2);
        ptr+=l850*sizeof(long);
    }
    fclose(f2);
    fprintf(f3,"13     3 147456\n");
    ptrc=(b147456)+1;
    ptrl=(p147456)+1;
    for (i=1;i<=147456;i++)
    {
        fprintf(f3,"%8ld",*(ptrl++));
        j=*(ptrc++);
        fprintf(f3,"%2ld\n",j);
    }
    fclose(f3);
}

int wtT1(char * fn)
{
    FILE * f ;
    unsigned char * ptr;
    long * ptrl;
    unsigned char * ptrc;
    long i;
    long j;
    unsigned char c[4];
    f= fopen(fn,"wb");
    if (f == NULL) 
    {
        printf("File %s cannot be created!\n",fn);
        exit(-1);
    }
    ptrl = m64;
    ptr = (unsigned char *) ptrl;
    for (i=0;i<64;i++) 
    {
        fwrite(ptr,1,13,f);
        ptr+=l64*sizeof(long);
    }
    ptr = (unsigned char *) m850;
    for (i=0;i<850;i++) 
    {
        fwrite(ptr,1,170,f);
        ptr+=l850*sizeof(long);
    }
    ptrc=(b147456)+1;
    ptrl=(p147456)+1;
    for (i=1;i<=147456;i++)
    {
        c[0]=(*ptrl)%256;
        c[1]=((*(ptrl))/256)%256;
        c[2]=((*(ptrl++))/256)/256;
        c[3]=*(ptrc++);
        fwrite(c,1,4,f);
    }
    fclose(f);
}

int rdT1(char * fn)
{
    FILE * f ;
    unsigned char * ptr;
    long * ptrl;
    unsigned char * ptrc;
    long i;
    long j;
    unsigned char c[4];
    f= fopen(fn,"rb");
    if (f == NULL) 
    {
        printf("File %s does not exist!\n",fn);
        exit(-1);
    }
    malT();
    ptrl = m64;
    ptr = (unsigned char *) ptrl;
    for (i=0;i<64;i++) 
    {
        fread(ptr,1,13,f);
        ptr+=l64*sizeof(long);
    }
    *(ptr)=0000000000000000;
    ptr = (unsigned char *) m850;
    for (i=0;i<850;i++) 
    {
        fread(ptr,1,170,f);
        ptr+=l850*sizeof(long);
    }
    ptrc=(b147456)+1;
    ptrl=(p147456)+1;
    for (i=1;i<=147456;i++)
    {
        fread(c,1,4,f);
        *(ptrc++)=c[3];
        j=256*256*c[2]+256*c[1]+c[0];
        *(ptrl++)=j;
    }
    fclose(f);
    MKGRS64();
    MKGRS850();
}

int rdT1i(char * fn)
{
    FILE * f ;
    unsigned char * ptr;
    long * ptrl;
    unsigned char * ptrc;
    long i;
    long j;
    unsigned char c[4];
    f= fopen(fn,"rb");
    if (f == NULL) 
    {
        printf("File %s does not exist!\n",fn);
        exit(-1);
    }
    malTi();
    ptrl = mi64;
    ptr = (unsigned char *) ptrl;
    for (i=0;i<64;i++) 
    {
        fread(ptr,1,13,f);
        ptr+=l64*sizeof(long);
    }
    *(ptr)=0000000000000000;
    ptr = (unsigned char *) mi850;
    for (i=0;i<850;i++) 
    {
        fread(ptr,1,170,f);
        ptr+=l850*sizeof(long);
    }
    ptrc=(bi147456)+1;
    ptrl=(pi147456)+1;
    for (i=1;i<=147456;i++)
    {
        fread(c,1,4,f);
        *(ptrc++)=c[3];
        j=256*256*c[2]+256*c[1]+c[0];
        *(ptrl++)=j;
    }
    fclose(f);
    MKGRS64i();
    MKGRS850i();
}

void SVMco1(unsigned char *oldvec, unsigned char *newvec, co1el m, long l)
{
    long i,j1, j2, j3, * ptrl, trtA;
    unsigned char *ptrc;
    ptrl=(m->p98280)+1;
    ptrc=(m->b98280)+1;
   for(i=0;i<l;i++)
    {
	j2=(*(ptrl+i))+299;
	j3=i+300;
	trtA=(*(ptrc+i));
	if(trtA!=0) PUTTRIT(newvec, j2,(trtA*gettrittab[j3%5][oldvec[j3/5]])%3);
    }
}

void VM4096(unsigned char *oldvec, unsigned char *newvec, co1el m, long l1)
{
    long i, *ptrl, k, trtA, trtB, trtC, t1, pt;
    unsigned char *ptr[36856];
    for(i=0;i<36856;i++) ptr[i] = (unsigned char *) m->grs4096tab[i];
    pt=5*l1;
    for(i=0;i<1365;i++)
    {
	trtA=gettrittab[pt%5][oldvec[pt/5]];
	pt++;
	trtB=gettrittab[pt%5][oldvec[pt/5]];
	pt++;
	trtC=gettrittab[pt%5][oldvec[pt/5]];
	pt++;
	t1=(trtA*9)+(trtB*3)+trtC;
	if(t1!=0) VECADD2(newvec,ptr[(i*27)+t1],l1,l1+820);
    }
    trtA=gettrittab[pt%5][oldvec[pt/5]];
    for(i=0;i<trtA;i++) VECADD2(newvec,ptr[36855],l1,l1+820);
}

void VM4096NG(unsigned char *oldvec, unsigned char *newvec, co1el m, long l1)
{
    long i, *ptrl, k, trtA, trtB, trtC, t1, pt;
    unsigned char *ptr;
    ptrl=m->m4096;
    ptr = (unsigned char *) ptrl;    
    pt=5*l1;
    for(i=0;i<4096;i++)
    {
	trtB=gettrittab[pt%5][oldvec[pt/5]];
	pt++;
        for(k=0;k<trtB;k++) VECADD2(newvec,ptr,l1,l1+820);
	ptr+=l4096*sizeof(long);
    }
}

void VM24(unsigned char *oldvec, unsigned char *newvec, co1el m)
{
    long startpt,i,j,k,*ptrl,l1,l2,trt,t1;
    unsigned char *ptr;
    startpt=19716;
    ptrl=m->m24t;
    ptr = (unsigned char *) ptrl;    
    for(k=0;k<24;k++)
    {
	l1=startpt+(820*k);
	for(i=0;i<24;i++)
	{
	    trt=gettrittab[i%5][ptr[i/5]];
	    for(j=0;j<trt;j++) 
	    {
		l2=startpt+(820*i);
		VECADD3(newvec,oldvec,l1,l1+820,l2);
	    }
	}
	ptr+=l24*sizeof(long);
    }
}

void VM298(unsigned char *oldvec, unsigned char *newvec, co1el m)
{
   long trtB,i,k, * ptrl;
    unsigned char * ptr;
    ptrl = m->m298;
    ptr = (unsigned char *) ptrl;
    for(i=0;i<298;i++)
    {
	trtB=gettrittab[i%5][oldvec[i/5]];
        for(k=0;k<trtB;k++) VECADD(newvec,ptr,0,60);
	ptr+=l298*sizeof(long);
   }
}

void VMco1(unsigned char *oldvec, unsigned char *newvec, co1el m)
{
    long i;
    for(i=0;i<41808;i++) newvec[i]=0;
    for(i=0;i<41808;i++) vectemp[i]=0;
    VM298(oldvec, newvec, m);
    SVMco1(oldvec, newvec, m, 98280);
    /*cpvec(oldvec, newvec, 19716, 41808);*/
    cpvec(newvec, vectemp, 0, 19716);
    for(i=0;i<24;i++) VM4096(oldvec, vectemp, m, 19716+(i*820));
    VM24(vectemp, newvec, m);
}    

void VMco1NG(unsigned char *oldvec, unsigned char *newvec, co1el m)
/* This version without grease is quicker if it's only going to be used
a few times: otherwise, grease m first and then use VMco1 instead */
{
    long i;
    for(i=0;i<41808;i++) newvec[i]=0;
    for(i=0;i<41808;i++) vectemp[i]=0;
    VM298(oldvec, newvec, m);
    SVMco1(oldvec, newvec, m, 98280);
    /*cpvec(oldvec, newvec, 19716, 41808);*/
    cpvec(newvec, vectemp, 0, 19716);
    for(i=0;i<24;i++) VM4096NG(oldvec, vectemp, m, 19716+(i*820));
    VM24(vectemp, newvec, m);
}    

void SVMT(unsigned char *oldvec, unsigned char *newvec, long l)
{
    long i,j1, j2, j3, * ptrl, trtA;
    unsigned char *ptrc;
    ptrl=(p147456)+1;
    ptrc=(b147456)+1;
   for(i=0;i<l;i++)
    {
	j2=(*(ptrl+i))+61579;
	j3=i+61580;
	trtA=(*(ptrc+i));
	if(trtA!=0) PUTTRIT(newvec, j2,(trtA*gettrittab[j3%5][oldvec[j3/5]])%3);
    }

}

void SVMTi(unsigned char *oldvec, unsigned char *newvec, long l)
{
    long i,j1, j2, j3, * ptrl, trtA;
    unsigned char *ptrc;
    ptrl=(pi147456)+1;
    ptrc=(bi147456)+1;
   for(i=0;i<l;i++)
    {
	j2=(*(ptrl+i))+61579;
	j3=i+61580;
	trtA=(*(ptrc+i));
	if(trtA!=0) PUTTRIT(newvec, j2,(trtA*gettrittab[j3%5][oldvec[j3/5]])%3);
    }

}

void VMT850(unsigned char *oldvec, unsigned char *newvec)
{
    long i, *ptrl, k;
    unsigned char *ptr, c;
    ptrl = m850;
    ptr = (unsigned char *) ptrl;
    for(i=0;i<170;i++)
    {
	c=oldvec[i];
	if(c!=0) VECADD(newvec,grs850tab[(i*243)+c],0,170);
    }
}
    
void VMT850i(unsigned char *oldvec, unsigned char *newvec)
{
    long i, *ptrl, k;
    unsigned char *ptr, c;
    ptrl = mi850;
    ptr = (unsigned char *) ptrl;
    for(i=0;i<170;i++)
    {
	c=oldvec[i];
	if(c!=0) VECADD(newvec,grs850tabi[(i*243)+c],0,170);
    }
}
    
void VMT64(unsigned char *oldvec, unsigned char *newvec, long l1)
{
    long i, *ptrl, k;
    unsigned char *ptr;
    ptrl = m64;
    ptr = (unsigned char *) ptrl;
    for(i=0;i<13;i++)
    {
	VECADD2(newvec,grs64tab[(i*243)+oldvec[i+l1]],l1,l1+13);
    }
}

void VMT64i(unsigned char *oldvec, unsigned char *newvec, long l1)
{
    long i, *ptrl, k;
    unsigned char *ptr;
    ptrl = mi64;
    ptr = (unsigned char *) ptrl;
    for(i=0;i<13;i++)
    {
	VECADD2(newvec,grs64tabi[(i*243)+oldvec[i+l1]],l1,l1+13);
    }
}

void VMT(unsigned char *oldvec, unsigned char *newvec)
{
    long i;
    for(i=0;i<41808;i++) newvec[i]=0;
    VMT850(oldvec, newvec);
    for(i=0;i<759;i++) VMT64(oldvec, newvec, 172+(i*16));
    SVMT(oldvec, newvec, 147456);
}    

void VMTi(unsigned char *oldvec, unsigned char *newvec)
{
    long i;
    for(i=0;i<41808;i++) newvec[i]=0;
    VMT850i(oldvec, newvec);
    for(i=0;i<759;i++) VMT64i(oldvec, newvec, 172+(i*16));
    SVMTi(oldvec, newvec, 147456);
}    

void SMU(co1el m1, co1el m2, co1el m3)
{
    long i, j1, j2, * ptrlA, * ptrlB, * ptrlC;
    unsigned char * ptrA, * ptrB, * ptrC, c1, c2;
    ptrlA=m1->p98280;
    ptrA=m1->b98280;
    ptrlB=m2->p98280;
    ptrB=m2->b98280;
    ptrlC=m3->p98280;
    ptrC=m3->b98280;
    for(i=0;i<=98280;i++)
    {
	j1=*(ptrlA++);
	j2=*(ptrlB+j1);
	*(ptrlC++)=j2;
	c1=*(ptrA++);
	c2=*(ptrB+j1);
	if(c1==c2) *(ptrC++)=1;
	else *(ptrC++)=2;
    } 
}
    
void VM24B(unsigned char *oldvec, unsigned char *newvec, co1el m)
{
    long i,j,k,*ptrl,trt,t1;
    unsigned char *ptr;
    ptrl=m->m24;
    ptr = (unsigned char *) ptrl;    
    for(k=0;k<24;k++)
    {
	trt=gettrittab[k%5][oldvec[k/5]];
	for(j=0;j<trt;j++) 
	{
	    VECADD(newvec,ptr,0,5);
	}
	ptr+=l24*sizeof(long);
    }
}

void MU24(co1el m1, co1el m2, co1el m3)
{
    long j, k;
    unsigned char * ptrA, * ptrB;
    ptrA=(unsigned char *) m1->m24;
    ptrB=(unsigned char *) m3->m24;
    for(j=0;j<24;j++)
    {
	for(k=0;k<5;k++) ptrB[k]=0;
	VM24B(ptrA, ptrB, m2);
	ptrA+=l24*sizeof(long);
	ptrB+=l24*sizeof(long);
    }	
}

void MU4096(co1el m1, co1el m2, co1el m3)
{
    long j, k;
    unsigned char * ptrA, * ptrB;
    ptrA=(unsigned char *) m1->m4096;
    ptrB=(unsigned char *) m3->m4096;
    for(j=0;j<4096;j++)
    {
	for(k=0;k<820;k++) ptrB[k]=0;
	VM4096(ptrA, ptrB, m2, 0);
	ptrA+=l4096*sizeof(long);
	ptrB+=l4096*sizeof(long);
    }	
}

void MU298(co1el m1, co1el m2, co1el m3)
{
    long j, k;
    unsigned char * ptrA, * ptrB;
    ptrA=(unsigned char *) m1->m298;
    ptrB=(unsigned char *) m3->m298;
    for(j=0;j<298;j++)
    {
	for(k=0;k<60;k++) ptrB[k]=0;
	VM298(ptrA, ptrB, m2);
	ptrA+=l298*sizeof(long);
	ptrB+=l298*sizeof(long);
    }	
}

void MULCO1(co1el m1, co1el m2, co1el m3)
{
    MU24(m1, m2, m3);
    MU298(m1, m2, m3);
    SMU(m1, m2, m3);
    MU4096(m1, m2, m3);
    transpose24(m3);
}

long TRACE24(co1el m)
{
    long i,j;
    unsigned char * ptr;
    ptr=(unsigned char *) m->m24;
    i=0;
    for(j=0;j<24;j++)
    {
	i+=gettrittab[j%5][ptr[j/5]];
	ptr+=l24*sizeof(long);
    }
    return i;
}

long TRACE4096(co1el m)
{
    long i,j;
    unsigned char * ptr;
    ptr=(unsigned char *) m->m4096;
    i=0;
    for(j=0;j<4096;j++)
    {
	i+=gettrittab[j%5][ptr[j/5]];
	ptr+=l4096*sizeof(long);
    }
    return i;
}

long TRACE298(co1el m)
{
    long i,j;
    unsigned char * ptr;
    ptr=(unsigned char *) m->m298;
    i=0;
    for(j=0;j<298;j++)
    {
	i+=gettrittab[j%5][ptr[j/5]];
	ptr+=l298*sizeof(long);
    }
    return i;
}

long TRACESLM(co1el m)
{
    long i, j1, j2, * ptrl;
    unsigned char * ptr, c1, c2;
    ptrl=(m->p98280)+1;
    ptr=(m->b98280)+1;
    j2=0;
    for(i=1;i<=98280;i++)
    {
	j1=*(ptrl++);
	c1=*(ptr++);
	if(j1==i) j2+=c1;
    } 
    return j2;
}

long CO1TRACE(co1el m)
{
    long i1,i2,i3,i4,j;
    i1=TRACE24(m);
    i3=TRACE4096(m);
    i2=i1*i3;
    i3=TRACESLM(m);
    i4=TRACE298(m);
    j=(i2+i3+i4)%3;
    return j;
}

/* note - this only copies the matrices and the transpose, not the grease */

void COPYCO1(co1el m1, co1el m2)
{
    long *ptl1, *ptl2;
    unsigned char *ptc1, *ptc2;
    int i;
    ptl1=m1->m24;
    ptl2=m2->m24;
    for (i=0;i<24*l24;i++) *(ptl2++)=*(ptl1++);
    ptl1=m1->m4096;
    ptl2=m2->m4096;
    for (i=0;i<4096*l4096;i++) *(ptl2++)=*(ptl1++);
    ptl1=m1->m298;
    ptl2=m2->m298;
    for (i=0;i<298*l298;i++) *(ptl2++)=*(ptl1++);
    ptl1=m1->p98280;
    ptl2=m2->p98280;
    for (i=0;i<=98280;i++) *(ptl2++)=*(ptl1++);
    ptc1=m1->b98280;
    ptc2=m2->b98280;
    for (i=0;i<=98280;i++) *(ptc2++)=*(ptc1++);
    transpose24(m2);
}	  
/* note - m2 is temp., m1 is being powered and m3 is the output */
/* m1 is the only one that needs a big malloc */

void CPWRO(co1el m1, co1el m2, co1el m3, long pwr)
/* Old version which is crap */
{
    long i1,i2,i3;

    COPYCO1(m1,m2);
    COPYCO1(m1,m3);
    i1=pwr;
    i2=0;
    while ((i1%2)==0) 
    {
	i1=i1/2;
	i2+=1;
    }
    for(i3=0;i3<i2;i3++)
    {	
	printf("squaring\n");
        MKGRS4096A(m1); 
	MULCO1(m2,m1,m3);
	COPYCO1(m3,m1);
	COPYCO1(m3,m2);
    }
    i2=0;
    while ((i1%3)==0) 
    {
	i1=i1/3;
	i2+=1;
    }
    for(i3=0;i3<i2;i3++)
    {	
	printf("cubing\n");
        MKGRS4096A(m1); 
	printf("1st mul\n");
	MULCO1(m2,m1,m3);
	COPYCO1(m3,m2);
	printf("2nd mul\n");
	MULCO1(m2,m1,m3);
	COPYCO1(m3,m2);
	COPYCO1(m3,m1);
    }
    if (i1!=1)
    {
	MKGRS4096A(m1);
	for(i3=1;i3<i1;i3++)
	{
	    printf("multiplying\n");
	    MULCO1(m2,m1,m3);
	    COPYCO1(m3,m2);
	}	 
    }
    COPYCO1(m3,m1);
}

void CPWR(co1el m1, co1el m2, co1el m3, long pwr)
/* New version which should be less crap */
{
    long i1,i2,i3,i;
    if (pwr <= 1) printf("Error: power must be greater than 1\n");
    COPYCO1(m1,m2);
    COPYCO1(m1,m3);
    i1=pwr;
    i2=0;
    while (i1>0)
    {
        i2+=1;
        i1=i1/2;
    }
    i1=pwr-(1<<(i2-1));
    MKGRS4096A(m1); 
    while (i2>1) 
    {
        i2-=1;
	printf("squaring\n");
        MKGRS4096A(m2); 
	MULCO1(m2,m2,m3);
	COPYCO1(m3,m2);
        if((2*i1) > ((1<<i2) -1))
        {
            i1=i1-(1<<(i2-1));
      	    printf("multiplying\n");
	    MULCO1(m2,m1,m3);
	    COPYCO1(m3,m2);
        }
    }
    printf("powering finished\n");
}
long COR(co1el m)
{
    long j,i;
    rdvec("vect",vec0);
    MKGRS4096A(m); 
    cpvec(vec0,vec2,0,41808);
    for(j=1;j<120;j++) 
    { 
	 VMco1(vec2, vec3, m);
         cpvec(vec3,vec2,0,41808); 
	 if(veccomp(vec2,vec0)==0)  
	 { 
	     return j; 
	 }   
    } 
    return 120;
}

long getpos(unsigned char *veca)
{
    long j,k;
    for(j=0;j<209040;j++)
    {
	k=gettrittab[j%5][veca[j/5]];
	if(k!=0) 
	{
	    return(j);
	}
    }
    return(0);
}
/*
nb this next one doesn't work
*/

long ech()
{
    long i, j, k, l, m, n, *dunlst, *poslst, flg1, flg2, dimn, numdun;
    dunlst = malloc(1000*sizeof(long));
    poslst = malloc(1000*sizeof(long));
    i=0;
    flg2=0;
    numdun=0;
    while((i<1000)&&(flg2==0))
    {
	cpvec(bss[i],vectemp,0,41808);
	flg1=0;
	j=0;
	dunlst[i]=0;
	poslst[i]=getpos(vectemp);
	flg1=poslst[i];
	if(flg1==0) 
	{
	    for(k=i;k<1000;k++) 
	    {
		dunlst[k]=1;
		numdun++;
	    }
	    dimn=i;
	    flg2=1;
	}
	i++;
    }
  
printf("%ld \n",dimn); 
    i=0;
    while((i<209040)&&(numdun<1000))
    {
	i++;
	flg2=0;
	for(j=0;j<dimn;j++)
	{
	    cpvec(bss[j],vectemp,0,41808);
	    if((poslst[j]=i)&&(flg2==0))
	    {
		k=j;
		dunlst[j]=1;
		numdun++;
		m=gettrittab[i%5][vectemp[i/5]];
		if(m==2) VECADD(bss[j],vectemp,0,41808);
		flg2=1;
	    }
	    if((poslst[j]=i)&&(flg2==1))
	    {
		l=gettrittab[i%5][vectemp[i/5]];
		VECADD(bss[j],bss[k],0,41808);
		if(l==1) VECADD(bss[j],bss[k],0,41808);
		poslst[j]=getpos(bss[j]);
		if(poslst[j]==0) 
		{
		    cpvec(bss[dimn-1],bss[j],0,41808);
		    cpvec(bss[999],bss[dimn-1],0,41808);
		    return(0);
		}
	    }
	}
    }
    return(dimn);
}
		
	
    	    
int wtbss(char * fn1, long l)
{
    FILE * f1 ;
    unsigned char * ptr, bsshead[12];
    long * ptrl;
    unsigned char * ptrc;
    long i;
    long j;
    f1= fopen(fn1,"wb");
    if (f1 == NULL) 
    {
        printf("File %s cannot be created!\n",fn1);
        exit(-1);
    }
    
    bsshead[0]=3;
    bsshead[1]=0;
    bsshead[2]=0;
    bsshead[3]=0;
    bsshead[4]=l%256;
    bsshead[5]=l/256;
    bsshead[6]=0;
    bsshead[7]=0;
    bsshead[8]=18;
    bsshead[9]=1;
    bsshead[10]=3;
    bsshead[11]=0;

    fwrite(bsshead,1,12,f1);
    for (i=0;i<l;i++) 
    {
    for (j=0;j<39377;j++) vectemp[j]=0;
    ptr1=0;
    ptr2=0;
    FUNGAP(bss[i],vectemp,298,2);
    FUNGAP(bss[i],vectemp,98280,0);
    for (j=0;j<24;j++)     FUNGAP(bss[i],vectemp,4096,4);
        fwrite(vectemp,1,39377,f1);
    }
    fclose(f1);
}
int vec2bss(long di, unsigned char *veca)
{
    long i,j,k,p1,p2;
    p1=getpos(veca);
    for(i=0;i<di;i++)
    { 
	j=poslst2[i];
	poslst4[i]=j;
	j=poslst3[i];
	poslst5[i]=j;
    }
    i=0;
    k=poslst4[0];
    j=poslst5[0];
    while((k<p1)&&(i<di))
    {
	poslst2[i]=k;
	k=poslst4[i];
	poslst3[i]=j;
	j=poslst5[i];
	i++;
    }
    poslst2[i]=p1;	
    poslst3[i]=di;
    while(i<di)
    {
        k=poslst4[i];
        j=poslst5[i];
	poslst2[i+1]=k;
	poslst3[i+1]=j;
	i++;
    }
}
		

int sortpos(long di)
{
    long i,j,m,m1,m2,pm;
    for(i=0;i<di;i++)
    { 
	j=poslst1[i];
	poslst4[i]=j;
    }
    for(i=0;i<di;i++)
    {
        m=250000;
	j=0;	
	m1=0;
	while(j<di)
	{
	    m2=poslst4[j];
	    if(m2<m)
	    { 
		m=m2;
		pm=j;
		m1=1;
	    }
	    j++;
	}
	poslst2[i]=m;
	poslst3[i]=pm;
	poslst4[pm]=250000;
    }
}

long isli(unsigned char *veca, long dimn)
{
    long i,p,t1,t2;  
   i=0;
    while(i<dimn)
    {
        p=getpos(veca);
	if(p==0) return(0);
	printf("p is %ld\n",p);
	while((poslst2[i]<p)&&(i<dimn)) i++;
	if(i==dimn) return(1);
	if(poslst2[i]>p)
	{
	    return(1);
	}
	if(p==poslst2[i])
	{
	    t1=gettrittab[p%5][veca[p/5]];
	    t2=gettrittab[p%5][bss[poslst3[i]][p/5]];
	    if(getpos(bss[poslst3[i]])!=p) printf("cock up A\n");
	    VECADD(veca,bss[poslst3[i]],0,41808);
	    if(t1==t2) VECADD(veca,bss[poslst3[i]],0,41808);
	    if(getpos(veca)==p) printf("%ld %ld cock up\n", t1, t2);
	}
    }
    return(0);
}
